
#include "StateClasses.h"
#include "StateMachine.h"

StateMachine::StateMachine (Actions &a)
:
actions (a),
stateContext (*this, *this, a),
day (new Day (stateContext)),
off (new Off (stateContext)),
moving (new Moving (stateContext)),
timing (new Timing (stateContext)),
currentState (day)
{}

StateMachine::~StateMachine()
{
    currentState = 0;

    delete day;
    delete off;
    delete moving;
    delete timing;
}

void StateMachine::Dark ()
{
    currentState->Dark();
}

void StateMachine::Light ()
{
    currentState->Light();
}

void StateMachine::Movement ()
{
    currentState->Movement();
}

void StateMachine::NoMovement ()
{
    currentState->NoMovement();
}

void StateMachine::Timeout ()
{
    currentState->Timeout();
}

const char * StateMachine::Report () const
{
    return currentState->Name();
}
